/*
Copyright 2018 Ultimaker

Licensed under the Apache License, Version 2.0 (the "License");
you may not use this file except in compliance with the License.
You may obtain a copy of the License at

    http://www.apache.org/licenses/LICENSE-2.0

Unless required by applicable law or agreed to in writing, software
distributed under the License is distributed on an "AS IS" BASIS,
WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
See the License for the specific language governing permissions and
limitations under the License.
*/

// Code generated by lister-gen. DO NOT EDIT.

package v1alpha1

import (
	v1alpha1 "github.com/Ultimaker/gcp-operator/pkg/apis/gcp/v1alpha1"
	"k8s.io/apimachinery/pkg/api/errors"
	"k8s.io/apimachinery/pkg/labels"
	"k8s.io/client-go/tools/cache"
)

// GCPCloudSQLInstanceLister helps list GCPCloudSQLInstances.
type GCPCloudSQLInstanceLister interface {
	// List lists all GCPCloudSQLInstances in the indexer.
	List(selector labels.Selector) (ret []*v1alpha1.GCPCloudSQLInstance, err error)
	// GCPCloudSQLInstances returns an object that can list and get GCPCloudSQLInstances.
	GCPCloudSQLInstances(namespace string) GCPCloudSQLInstanceNamespaceLister
	GCPCloudSQLInstanceListerExpansion
}

// gCPCloudSQLInstanceLister implements the GCPCloudSQLInstanceLister interface.
type gCPCloudSQLInstanceLister struct {
	indexer cache.Indexer
}

// NewGCPCloudSQLInstanceLister returns a new GCPCloudSQLInstanceLister.
func NewGCPCloudSQLInstanceLister(indexer cache.Indexer) GCPCloudSQLInstanceLister {
	return &gCPCloudSQLInstanceLister{indexer: indexer}
}

// List lists all GCPCloudSQLInstances in the indexer.
func (s *gCPCloudSQLInstanceLister) List(selector labels.Selector) (ret []*v1alpha1.GCPCloudSQLInstance, err error) {
	err = cache.ListAll(s.indexer, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.GCPCloudSQLInstance))
	})
	return ret, err
}

// GCPCloudSQLInstances returns an object that can list and get GCPCloudSQLInstances.
func (s *gCPCloudSQLInstanceLister) GCPCloudSQLInstances(namespace string) GCPCloudSQLInstanceNamespaceLister {
	return gCPCloudSQLInstanceNamespaceLister{indexer: s.indexer, namespace: namespace}
}

// GCPCloudSQLInstanceNamespaceLister helps list and get GCPCloudSQLInstances.
type GCPCloudSQLInstanceNamespaceLister interface {
	// List lists all GCPCloudSQLInstances in the indexer for a given namespace.
	List(selector labels.Selector) (ret []*v1alpha1.GCPCloudSQLInstance, err error)
	// Get retrieves the GCPCloudSQLInstance from the indexer for a given namespace and name.
	Get(name string) (*v1alpha1.GCPCloudSQLInstance, error)
	GCPCloudSQLInstanceNamespaceListerExpansion
}

// gCPCloudSQLInstanceNamespaceLister implements the GCPCloudSQLInstanceNamespaceLister
// interface.
type gCPCloudSQLInstanceNamespaceLister struct {
	indexer   cache.Indexer
	namespace string
}

// List lists all GCPCloudSQLInstances in the indexer for a given namespace.
func (s gCPCloudSQLInstanceNamespaceLister) List(selector labels.Selector) (ret []*v1alpha1.GCPCloudSQLInstance, err error) {
	err = cache.ListAllByNamespace(s.indexer, s.namespace, selector, func(m interface{}) {
		ret = append(ret, m.(*v1alpha1.GCPCloudSQLInstance))
	})
	return ret, err
}

// Get retrieves the GCPCloudSQLInstance from the indexer for a given namespace and name.
func (s gCPCloudSQLInstanceNamespaceLister) Get(name string) (*v1alpha1.GCPCloudSQLInstance, error) {
	obj, exists, err := s.indexer.GetByKey(s.namespace + "/" + name)
	if err != nil {
		return nil, err
	}
	if !exists {
		return nil, errors.NewNotFound(v1alpha1.Resource("gcpcloudsqlinstance"), name)
	}
	return obj.(*v1alpha1.GCPCloudSQLInstance), nil
}
